{*******************************************************}
{                                                       }
{   Demo project author : Gabriel Anass TAOUSSI         }
{                                                       }
{*******************************************************}

unit NotSoAcceptableTriSurface;

interface

uses
  { Windows }
  Winapi.Windows,
  Winapi.Messages,

  { System }
  System.SysUtils,
  System.Variants,
  System.Classes,

  { Vcl }
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.ExtCtrls,

  { Steema }
  VCLTee.TeeTools,
  VCLTee.TeEngine,
  VCLTee.TeeProcs,
  VCLTee.Chart,
  VCLTee.TeeSurfa,
  VCLTee.TeeTriSurface,
  VCLTee.TeeOpenGL;

type
  TChartAccess=class(TCustomAxisPanel);

type
  TMyTriSurfaceSeries=class(TTriSurfaceSeries);

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Timer1: TTimer;
    ChartTool1: TRotateTool;
    TeeOpenGL1: TTeeOpenGL;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with Chart1 do
  begin

    { Walls }
    BackWall.Size                     := 10;
    BackWall.Transparent              := False;
    BottomWall.Size                   := 10;
    LeftWall.Size                     := 10;
    RightWall.Size                    := 10;

    { Legend }
    Legend.Brush.Gradient.Visible     := False;
    Legend.Visible                    := False;


    { 3D options  }
    Chart3DPercent                    := 100;
    DepthAxis.Visible                 := True;

    View3DOptions.Orthogonal          := False;
    View3DOptions.Perspective         := 100;
    View3DOptions.Zoom                := 30;
    View3DWalls                       := False;

    AllowPanning                      := pmNone;
    Panning.MouseWheel                := pmwNone;
    Zoom.MouseButton                  := TMouseButton.mbMiddle;
    ZoomWheel                         := pmwNormal;
    TabOrder                          := 1;
    TChartAccess(Chart1).ParallelThreads:=TTeeCPU.NumberOfProcessors;
    ColorPaletteIndex                 := 13;

    Axes.Automatic := true;

    { Chart speed tricks }
    BevelOuter       :=bvNone;
    BufferedDisplay  :=True;
    ClipPoints       :=False;
    Axes.FastCalc    :=True;  // <-- bypass overflow checkings...
    Title.Hide;
    Legend.Hide;
    Walls.Left.Hide;
    Hover.Visible := false;

    var Series1 := TMyTriSurfaceSeries.Create(Chart1);
    { Series speed tricks }
    Series1.Pen.Hide;
    Series1.FastBrush                    := True;
    TMyTriSurfaceSeries(Series1).Reuse3D := true;

    { Other configs }
    Series1.CacheTriangles         := true;
    Series1.Selected.Hover.Visible := False;
    Series1.Transparency           := 0;
    Series1.PaletteStyle           := TTeePaletteStyle.psRainbow;
    Series1.UseColorRange          := False;
    Series1.UsePalette             := true;
    Series1.XValues.Name           := 'X';
    Series1.YValues.Name           := 'Y';
    Series1.ZValues.Name           := 'Z';
    Series1.XValues.Order          := loNone;
    Series1.YValues.Order          := loNone;
    Series1.ZValues.Order          := loNone;

    Series1.FillSampleValues(3600); // This is the lowest acceptable sample count
    AddSeries(Series1);
  end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  With Chart1.View3DOptions do
  begin
    Rotation:=Rotation+1;
    if Rotation>360 then Rotation:=Rotation-360;
  end;

  // refills values
  Chart1.Series[0].FillSampleValues(3600);

  Timer1.Enabled:=True;
end;

end.
